/'
 ' This DSD implements the chef assignment for a previously selected event.
 '/
@startuml
title 3 assignChef
actor Actor
participant "CatERingAppManager.eventManager:EventManager" as em
participant "CatERingAppManager.event:Event" as e
participant "r:EventReceiver" as r

Actor -> em++: assignChef(chef)
alt currentEvent == null
  em -->> Actor: throw UseCaseLogicException
else !chef.isChef()
  em -->> Actor: throw UseCaseLogicException
else
  em -> e ++: setAssignedChef(chef)
  deactivate e

  group for each r in receivers
    em -> r++:notifyChefAssigned(currentEvent, chef)
    deactivate r
  end 

  em -->> Actor --:
end
@enduml
